import telnetlib
import re
import time
from socket import *


#Connect to device with user provided credentials
def connectToDevice(DeviceIPAddress):

    #Wait for login prompt from device and enter user name when prompted
    telnet_obj.read_until(b"login")
    telnet_obj.write(user.encode('ascii') + b"\r\n")


    #Wait for password prompt and enter password when prompted by device
    telnet_obj.read_until(b"Password: ")
    telnet_obj.write(password.encode('ascii') + b"\r\n")


    #Wait for device response
    log_result = telnet_obj.read_until(b"successfully\r\n")
    telnet_obj.read_until(b">")
    # print(log_result)

    #Check if login attempt was successful
    if b"successfully" in log_result:
        return True
    elif "denied" in log_result:
        return False


DeviceIP = "192.168.10.47"              #Device IP address
user = "admin"                          #input("Default User name (admin) :") #Device Telnet user name
password = "admin"                      # input("Default Password (admin) :") #Device Telnet password


#Create a new TELNET object
telnet_obj = telnetlib.Telnet(DeviceIP)


#Connect to the device using credentials provided
if connectToDevice(DeviceIP) == True:
    print("\nLogged in successfully... Connected to device", DeviceIP, "\n")
else:
    print("Login failed!!!! Please check login credentials or Device IP Address\n\n")    
    telnet_obj.close()
    exit(0)


#'''''''''''''''''''''''Main Method''''''''''''''''
response = telnet_obj.read_eager() #Flush any data that may be left in the input buffer

## ADC & DAC commands ##
def adc_read(num):
    telnet_obj.write(b"adc read " + str(num).encode("ascii") + b"\r\n")
    response = telnet_obj.read_until(b">")
    print("\nAdc Status", num, ":", re.split(br'[&>]', response)[0].decode())

def adc_offset_get(num):
    telnet_obj.write(b"adc offset get " + str(num).encode("ascii") + b"\r\n")
    response = telnet_obj.read_until(b">")
    print("\nAdc offset get", num, ":", re.split(br'[&>]', response)[0].decode())

def adc_config_get():
    telnet_obj.write(b"adc config get\r\n")
    response = telnet_obj.read_until(b">")
    print("\nAdc config get",":", re.split(br'[&>]', response)[0].decode())

def adc_range_get(num):
    telnet_obj.write(b"adc range get " + str(num).encode("ascii") + b"\r\n")
    response = telnet_obj.read_until(b">")
    print("\nAdc range get", num, ":", re.split(br'[&>]', response)[0].decode())
    
def adc_config_set(value):
    telnet_obj.write(b"adc config set " + str(value).encode("ascii") + b"\r\n")
    response = telnet_obj.read_until(b">")
    print("\nAdc config set command sent....\n")
    
def adc_offset_set(num, sign, value):
    telnet_obj.write(b"adc offset set " + str(num).encode("ascii") + b" " + str(sign).encode("ascii") + b" " +str(value).encode("ascii") + b"\r\n")
    response = telnet_obj.read_until(b">")
    print("\nAdc offset set", num, "command sent....")

def adc_range_set(num, value):
    telnet_obj.write(b"adc range set " + str(num).encode("ascii") + b" " + str(value).encode("ascii") + b"\r\n")
    response = telnet_obj.read_until(b">")
    print("\nAdc range set", num, "command sent....\n")

def dac_read(num):
    telnet_obj.write(b"dac read " + str(num).encode("ascii") + b"\r\n")
    response = telnet_obj.read_until(b">")
    print("\nDac Status", num, ":", re.split(br'[&>]', response)[0].decode())


def dac_set(num, value):
    telnet_obj.write(b"dac set " + str(num).encode("ascii") + b" " + str(value).encode("ascii") + b"\r\n")
    response = telnet_obj.read_until(b">")
    print("\nDac set", num, "command sent....")
    
## Configuration Commands ##
def ver():
    telnet_obj.write(b"ver\r\n")
    response = telnet_obj.read_until(b">")
    print("Firmware Version : ", re.split(br'[&>]', response)[0].decode())


def idset(value):
    telnet_obj.write(b"id set " + str(value).encode("ascii")+ b"\r\n")
    response = telnet_obj.read_until(b">")
    print("id set commands sent....\n")


def idget():
    telnet_obj.write(b"id get\r\n")
    response = telnet_obj.read_until(b">")
    print("Module ID : ", re.split(br'[&>]', response)[0].decode())


def usrset(value):
    telnet_obj.write(b"usr set " + str(value).encode("ascii")+ b"\r\n")
    response = telnet_obj.read_until(b">")
    print("usr set commands sent....\n")


def usrget():
    telnet_obj.write(b"usr get\r\n")
    response = telnet_obj.read_until(b">")
    print("User Name : ", re.split(br'[&>]', response)[0].decode())


def passset(value):
    telnet_obj.write(b"pass set " + str(value).encode("ascii")+ b"\r\n")
    response = telnet_obj.read_until(b">")
    print("pass set commands sent...\n.")


def passget():
    telnet_obj.write(b"pass get\r\n")
    response = telnet_obj.read_until(b">")
    print("Password : ", re.split(br'[&>]', response)[0].decode())



ver()
idset("12345678")
idget()
usrset("admin")
usrget()
passset("admin")
passget()

adc_config_get()
adc_config_set("5")

adc_range_set("000", 0)
adc_range_get("000")

adc_offset_set("000", 0, 100)
adc_offset_get("000")

adc_read("000")
dac_read("000")

dac_set("000",2)
dac_set("001",3)
dac_set("002",4)
dac_set("003",5)

#Finally close the TELNET session before exiting
telnet_obj.close()
    
    
